#!/usr/bin/ruby

require 'json'
require 'date'
require 'socket'
require 'syslog/logger'

$log = Syslog::Logger.new 'ipmi-power.rb'

type = ARGV[0]
$watts_avg = 0
$watts_cur = 0
$watts_min = 0
$watts_max = 0
$period    = 0

if type == 'dcmi'
  `/usr/bin/ipmitool dcmi power reading`.each_line do |line|
    if line =~ /Average power reading over sample period:[ ]*(.*) Watts/
      $watts_avg = $1
    end
    if line =~ /Instantaneous power reading:[ ]*(.*) Watts/
      $watts_cur = $1
    end
    if line =~ /Minimum during sampling period:[ ]*(.*) Watts/
      $watts_min = $1
    end
    if line =~ /Maximum during sampling period:[ ]*(.*) Watts/
      $watts_max = $1
    end
    if line =~ /Sampling period:[ ]*(.*) Seconds/
      $period = $1
    end
  end
end

$divisor = 1

if $watts_max.to_i > 10000
  $divisor = 10
end

$output = { 'name'      => 'power',
            'power_avg' => ($watts_avg.to_i/$divisor).to_i,
            'power_cur' => ($watts_cur.to_i/$divisor).to_i,
            'power_min' => ($watts_min.to_i/$divisor).to_i,
            'power_max' => ($watts_max.to_i/$divisor).to_i,
            'period'    => $period.to_i,
            'host'      => Socket.gethostname,
            'time'      => Time.now.to_i,
          }

puts(JSON.pretty_generate($output))
